const Sequelize = require("sequelize");
const db = require('../db/postgres.js');
const libs = `${process.cwd()}/libs`;

var Publication = db.define("Publication",{
    id:{
        type: Sequelize.INTEGER,
        allowNull:false,
        unique: true,
        primaryKey: true
    },
    filter:{
        type: Sequelize.ENUM("Artigo", "Tese", "Dissertação", "Relatório", "Periódico"),
        allowNull:false,
        validate: {
            notNull: { msg: "O campo categoria é obrigatória e aceita apenas os valores 'Artigo', 'Tese', 'Dissertação', 'Relatório', 'Periódico."},
        }
    },
    title:{
        type: Sequelize.STRING,
        allowNull:false,
    },
    authors:{
        type: Sequelize.STRING,
        allowNull:false
    },
    organization:{
        type: Sequelize.STRING,
        allowNull:false
    },
    year:{
        type:Sequelize.STRING,
        allowNull:false
    },
    text:{ 
        type: Sequelize.ENUM("Baixar","Acessar"),
        allowNull:false,
        validate: {
            notNull: { msg: "O campo origem é obrigatória e aceita apenas os valores 'Baixar', 'Acessar'."},
        }
    },
    link:{
        type: Sequelize.STRING
    },
    upload:{
        type: Sequelize.STRING
    },
    is_draft:{
        type:Sequelize.BOOLEAN,
        allowNull:false,
        defaultValue: true
    }

},
{timestamps: false});

module.exports = Publication;